#ifndef CARAPPL_H_
#define CARAPPL_H_

#include <map>
#include "veins/modules/application/ieee80211p/DemoBaseApplLayer.h"

#include "veins/modules/utility/Consts80211p.h"
#include "veins/modules/messages/DemoSafetyMessage_m.h"
#include "veins/base/connectionManager/ChannelAccess.h"

#include "examples/detour/messages/Car2XMessage_m.h"
#include "veins/modules/mobility/traci/TraCIMobility.h"
#include "veins/modules/mobility/traci/TraCICommandInterface.h"

using Veins::TraCIMobility;
using Veins::TraCICommandInterface;
using Veins::DemoBaseApplLayer;
using Veins::AnnotationManager;

class CarAppl: public DemoBaseApplLayer {

	public:
		~CarAppl();
		virtual void initialize(int stage);
		virtual void finish();

	protected:
		virtual void handleLowerMsg(cMessage* msg);
		virtual void handleSelfMsg(cMessage* msg);
		virtual void handlePositionUpdate(cObject* obj);

	protected:
		int myId;
		Veins::Coord curPosition;
		cMessage *stopSelf = new cMessage("stopSelf");
		bool haveForwarded;

		TraCIMobility* mobility;
		TraCICommandInterface* traci;
		TraCICommandInterface::Vehicle* traciVehicle;
		AnnotationManager* annotations;
};

#endif /* CARAPPL_H_ */
